//
//  P4Server.h
//  MBMenuExtra
//
//  Created by Michael Bishop on 12/3/09.
//  Copyright 2009 Perforce Software. All rights reserved.
//

#import <Cocoa/Cocoa.h>

// Server error constants


@class NGAReachability;
@class P4Response;
@class P4SpecManager;
@class P4Connection;
@class P4User;

typedef enum P4ServerStatus
{
    P4ServerStatusOffline
    , P4ServerStatusConnecting
    , P4ServerStatusError
    , P4ServerStatusOnline
} P4ServerStatus;



@interface P4ServerEntry : NSObject <NSCoding> {
@private
    NSString * _username;
    NSString * _portString;
    NSString * _encoding;
    P4User   * _user;
    NSArray * _users;
    NSError * _connectionError;
}

@property (nonatomic, readwrite, copy) NSString * portString;
@property (nonatomic, readwrite, copy) NSString * username;
@property (nonatomic, readwrite, copy) NSString * password;
@property (nonatomic, readwrite, copy) NSString * encoding;

@property (nonatomic, readonly, assign) P4Connection  * connection;
@property (nonatomic, readonly, assign) P4SpecManager * specManager;
@property (nonatomic, readonly, retain) P4User        * user;

@property (nonatomic, readonly)        BOOL              isUnicodeEnabled;
@property (nonatomic, readonly)        P4ServerStatus    status;
@property (nonatomic, readonly, retain) NSError * connectionError;

@property (nonatomic, readonly, copy)  NSArray *      users;

+ (NSArray*)encodings;
- (NSArray*)encodings;

- (BOOL)addressIsValid;
- (BOOL)userIsValid;
- (BOOL)passwordIsValid;

- (IBAction)refreshAll:(id)sender;

@end
